#!/bin/bash
# vim:set sw=4 ts=8 fileencoding=cp1251:::WINDOWS-1251[]
#
# Copyright(C) 2000-2013  
#
#    , 
#    .
#
#        ,
# ,    ,
#     ,
# ,      
#     
#      .
#
#
KVER=${1:-`uname -r`}
for BUILDDIR in /lib/modules/$KVER/build /usr/src/linux-$KVER /usr/src/linux-headers-$KVER /usr/src/kernels/$KVER
do
    if test -d $BUILDDIR || test -h $BUILDDIR
    then
    	break
    fi
done
if ! test -d $BUILDDIR && ! test -h $BUILDDIR
then
    echo "Cannot find any suitable kernel headers"
    exit 1
fi


#
# TODO:XXXX PROCESSOR_TYPE      ,    .
#      configure
#
PROC_TYPE="-DPROCESSOR_TYPE=PROC_TYPE_I386"
#PROC_TYPE="-DPROCESSOR_TYPE=PROC_TYPE_X64"

ln -s Makefile.drvcsp_linux.dist Makefile
# DEBUG="-DDEBUG"
 DEBUG=""
check_symbols=1
case $KVER in
2.6.*) make -C $BUILDDIR SUBDIRS=$PWD CFLAGS_MODULE="$DEBUG $PROC_TYPE -DUNIX -DLINUX -DCSP_LITE -DCSP_DRIVER -I/opt/cprocsp/include -I/opt/cprocsp/include/cpcsp -I/opt/cprocsp/include/interfaces -I/opt/cprocsp/include/reader -I/opt/cprocsp/src/drvcsp -DMODULE" modules;;
3.*)  make -C $BUILDDIR M=$PWD CFLAGS_MODULE="$DEBUG $PROC_TYPE -DUNIX -DLINUX -DCSP_LITE -DCSP_DRIVER -I/opt/cprocsp/include -I/opt/cprocsp/include/cpcsp -I/opt/cprocsp/include/interfaces -I/opt/cprocsp/include/reader -I/opt/cprocsp/src/drvcsp -DMODULE";;
4.*)  make -C $BUILDDIR M=$PWD CFLAGS_MODULE="$DEBUG $PROC_TYPE -DUNIX -DLINUX -DCSP_LITE -DCSP_DRIVER -I/opt/cprocsp/include -I/opt/cprocsp/include/cpcsp -I/opt/cprocsp/include/interfaces -I/opt/cprocsp/include/reader -I/opt/cprocsp/src/drvcsp -DMODULE"
      check_symbols=0;;
*) echo Unsupported kernel: $KVER; exit 1;;
esac 
VERS_FILE=/opt/cprocsp/include/Module.symvers.ia32
#VERS_FILE=/opt/cprocsp/include/Module.symvers.amd64
chmod +x gen_syms.sh check_syms.sh
./gen_syms.sh drvcsp.ko >drvcsp.syms
if test $check_symbols -eq 1
then
  if ! ./check_syms.sh drvcsp.syms $VERS_FILE CPCGetDefaultConfig CPCCreateProvider CPCInitMemoryLF
  then
      echo "Version info mismatch:"
      echo "$VERS_FILE:"
      cat $VERS_FILE
      echo "drvcsp.ko:"
      cat drvcsp.syms
      exit 1
  fi
fi

rm Makefile
